## liblopsub 1.0.3

=== Makefile ===
# Implicit rules are implemented in make as suffix rules. The following rule
# empties the suffix list to disable the predefined implicit rules. This
# increases performance and avoids hard-to-debug behaviour.
.SUFFIXES:
MAKEFLAGS += -Rr
ifeq ("$(origin CC)", "default")
        CC := cc
endif
.ONESHELL:
.SHELLFLAGS := -ec

PREFIX ?= /usr/local
M4 := m4
LN := ln -f
LEX := lex
RM := rm -f
AR := ar
GROFF := groff
CP := cp
INSTALL := install
GZIP := gzip -f9
ZCAT := zcat

DATE_FMT := +%B %Y
# To get a reproducible build, we use $(SOURCE_DATE_EPOCH) instead of the
# current time if this variable is set.
ifdef SOURCE_DATE_EPOCH
	DATE := $(shell LC_ALL=C date -u -d '@$(SOURCE_DATE_EPOCH)' \
		'$(DATE_FMT)' 2>/dev/null || LC_ALL=C date -u '$(DATE_FMT)')
else
	DATE := $(shell date '$(DATE_FMT)')
endif
GIT_VERSION := $(shell ./version-gen.sh)
PLAIN_VERSION := $(firstword $(subst -, , $(GIT_VERSION)))
MAJOR_VERSION := $(firstword $(subst ., , $(PLAIN_VERSION)))
SONAME := liblopsub.so.$(MAJOR_VERSION)
REALNAME := liblopsub.so.$(PLAIN_VERSION)
LINKERNAME:=liblopsub.so

m4_man_pages := lopsub-suite.5.gz lopsub.7.gz
all := $(m4_man_pages) $(REALNAME) lopsubgen lopsubgen.1.gz \
	lopsubex lopsubex.1.gz
all: $(all)

# deps
lopsubgen.o: lsg.h
lopsub.o lsg.o: lopsub.h lopsub-internal.h
lsg.o: lopsubgen.lsg.h lopsub-internal.h
lopsubex.o: lopsubex.lsg.h lopsub.h
config_file.c: lopsub-internal.h lopsub.h
version.o: version.c

# m4 stuff
gendoc := gendoc/gendoc.m4
%.h: %.h.m4 $(gendoc)
	$(M4) -DOUTPUT_MODE=C $(gendoc) $< > $@
$(m4_man_pages): %.gz: %.m4 version.c
	$(M4) -DGIT_VERSION=$(GIT_VERSION) -DDATE="$(DATE)" $< | $(GZIP) > $@

# flex
%.c: %.l
	$(LEX) -o $@ $<

# lopsubgen
lopsubgen.lsg.c lopsubgen.lsg.h: lopsubgen.suite lopsubgen-stage1 \
		lopsub-internal.h
	./lopsubgen-stage1 < $<
%.lsg.c: %.suite lopsubgen
	./lopsubgen --gen-c < $<
%.lsg.h: %.suite lopsubgen
	./lopsubgen --gen-header < $<
%.1.gz: %.suite lopsubgen
	./lopsubgen --gen-man=${@:.gz=} --version-string $(GIT_VERSION) < $<
	$(GZIP) ${@:.gz=}

# compiling
lsg1_objs := lopsubgen.o lsg1.o version.o
lsg_objs := lopsubgen.o lsg.o lopsubgen.lsg.o lopsub.o version.o
liblopsub_objs := config_file.o lopsub.o version.o
lopsubex_objs := lopsubex.o lopsubex.lsg.o $(liblopsub_objs)

$(lsg_objs) $(liblopsub_objs) $(lopsubex_objs): %.o: %.c
lopsubgen.o config_file.o:
	$(CC) -g -c -fPIC -o $@ ${@:.o=.c}
lsg1.o: lsg.c lsg.h
	$(CC) -g -DSTAGE1 -Wall -g -c $< -o $@
%.o: %.c
	$(CC) -Wall -I. -g -c -fPIC -o $@ $<

# linking
lopsubgen-stage1: $(lsg1_objs)
	$(CC) -Wall -g $(lsg1_objs) -o $@
lopsubgen: $(lsg_objs)
	$(CC) -Wall -g -o $@ $(lsg_objs)
$(REALNAME): $(liblopsub_objs)
	$(CC) --shared -Wl,-soname,liblopsub.so.$(MAJOR_VERSION) -o $@ $^
lopsubex: $(lopsubex_objs) $(REALNAME)
	$(CC) -Wall -g -o $@ $(lopsubex_objs)

# web
html := $(addprefix web/, $(addsuffix .html, \
	index lopsub-api lopsubgen.1 lopsubex.1 $(m4_man_pages)))
$(html): $(addprefix web/, $(addsuffix .html, header footer))

www: $(html)

web/lopsub-api.html: lopsub.h.m4
	$(M4) -DOUTPUT_MODE=HTML web/header.html $(gendoc) \
		$< web/footer.html > $@
web/index.html: web/lopsub.7.html
	$(LN) -s $(notdir $<) $@
web/%.html: %.gz
	$(CP) web/header.html $@
	$(ZCAT) $< | $(GROFF) -m man -Thtml | sed -e '1,/^<body>/d' >> $@

install: $(all)
	$(INSTALL) -d $(DESTDIR)$(PREFIX)/lib $(DESTDIR)$(PREFIX)/include \
		$(DESTDIR)$(PREFIX)/share/man/man1 $(DESTDIR)$(PREFIX)/share/man/man5 \
		$(DESTDIR)$(PREFIX)/share/man/man7 $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 644 $(REALNAME) $(DESTDIR)$(PREFIX)/lib
	$(LN) -s $(REALNAME) $(DESTDIR)$(PREFIX)/lib/$(SONAME)
	$(LN) -s $(SONAME) $(DESTDIR)$(PREFIX)/lib/$(LINKERNAME)
	$(INSTALL) -m 755 lopsubgen $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m 644 lopsub.h $(DESTDIR)$(PREFIX)/include
	$(INSTALL) -m 644 lopsub-internal.h $(DESTDIR)$(PREFIX)/include
	$(INSTALL) -m 644 lopsubgen.1.gz $(DESTDIR)$(PREFIX)/share/man/man1
	$(INSTALL) -m 644 lopsub-suite.5.gz $(DESTDIR)$(PREFIX)/share/man/man5
	$(INSTALL) -m 644 lopsub.7.gz $(DESTDIR)$(PREFIX)/share/man/man7

clean:
	$(RM) $(all) $(html) *.o *.man
distclean: clean
	$(RM) *.lsg.c *.lsg.h lopsubgen.c config_file.c lopsubgen-stage1 \
		lopsub.h lopsub.7 lopsub-suite.5 version.c

=== debian/control ===
Source: liblopsub
Section: libdevel
Priority: optional
Maintainer: Andre Noll <maan@tuebingen.mpg.de>
Build-Depends: m4, flex, debhelper (>= 10.0)
Standards-Version: 4.3.0
Homepage: http://people.tuebingen.mpg.de/maan/lopsub
Vcs-Browser: http://git.tuebingen.mpg.de/lopsub.git
Vcs-Git: git://git.tuebingen.mpg.de/lopsub.git

Package: liblopsub1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Long Option Parser for Subcommands
 Lopsub  is  an  open  source library written in C which aims to ease
 the task of creating, documenting and parsing the options of Unix
 command line utilities. It is suitable for simple commands as well
 as complex command line utilities with many subcommands where  each
 subcommand  has its own set of options. Options and documentation are
 kept together in a single file which can be translated to C code (to
 be included in the application), or to a manual page.  The library
 supports single-character short options and GNU-style long  options.
 The public API is well documented and stable.
Homepage: http://people.tuebingen.mpg.de/maan/lopsub

Package: liblopsub-dev
Architecture: any
Depends: ${shlibs:Depends}, liblopsub1 (= ${binary:Version}), ${misc:Depends}
Description: Long Option Parser for Subcommand - headers
 Lopsub  is  an  open  source library written in C which aims to ease
 the task of creating, documenting and parsing the options of Unix
 command line utilities. It is suitable for simple commands as well
 as complex command line utilities with many subcommands where  each
 subcommand  has its own set of options. Options and documentation are
 kept together in a single file which can be translated to C code (to
 be included in the application), or to a manual page.  The library
 supports single-character short options and GNU-style long  options.
 The public API is well documented and stable.
 This package contains the development environment for the lopsub library.

=== debian/rules ===
#!/usr/bin/make -f
# Invoke each target with `./debian/rules <target>'.  All targets should be
# invoked with the package root as the current directory.

sourcepackage := liblopsub
package := liblopsub1
devpackage := liblopsub-dev

define checkdir
	@test -f debian/rules -a -f lopsub.c || \
	(echo Not in correct source directory; exit 1)
endef

SRCTOP := $(shell pwd)
TMPDIR := $(SRCTOP)/debian/tmp
DESTDIR := $(SRCTOP)/debian/$(package)
DEVDIR := $(SRCTOP)/debian/$(devpackage)
DOCS_DIR := $(DESTDIR)/usr/share/doc/$(package)
DEVDOCS_DIR := $(DEVDIR)/usr/share/doc/$(devpackage)
TRIPLET := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

build-arch:
	$(checkdir)
	$(MAKE)
build-indep:
build: build-indep build-arch

clean:
	$(checkdir)
	-rm -f debian/substvars
	$(MAKE) distclean
	dh_clean

INST_OWN = -o root -g root
MAKE_DIR = install -p -d $(INST_OWN) -m 755
INST_FILE = install -c $(INST_OWN) -m 644

binary: build
	$(checkdir)
	$(MAKE) PREFIX=/usr install DESTDIR=$(TMPDIR)
	mv $(TMPDIR)/usr/lib $(TMPDIR)/usr/lib-$(TRIPLET)
	$(MAKE_DIR) $(TMPDIR)/usr/lib
	mv $(TMPDIR)/usr/lib-$(TRIPLET) $(TMPDIR)/usr/lib/$(TRIPLET)
	dh_install -p $(package)
	dh_install -p $(devpackage)
	$(MAKE_DIR) $(DESTDIR)/DEBIAN $(DOCS_DIR) $(DEVDOCS_DIR)
	echo 'activate-noawait ldconfig' > $(DESTDIR)/DEBIAN/triggers
	$(INST_FILE) debian/copyright $(DOCS_DIR)/copyright
	$(INST_FILE) debian/copyright $(DEVDOCS_DIR)/copyright
	$(INST_FILE) debian/changelog $(DOCS_DIR)/changelog.Debian
	$(INST_FILE) debian/changelog $(DEVDOCS_DIR)/changelog.Debian
	gzip -f9 $(DOCS_DIR)/changelog.Debian
	gzip -f9 $(DEVDOCS_DIR)/changelog.Debian
	dh_makeshlibs
	dh_shlibdeps
	dh_strip
	dh_shlibdeps
	dh_gencontrol
	dh_builddeb

binary-indep binary-arch: binary
.PHONY: clean build binary-arch binary-indep binary

## liblopsub 1.0.4

=== Makefile ===
--- 
+++ 
@@ -9,6 +9,13 @@
 .ONESHELL:
 .SHELLFLAGS := -ec
 
+# Recipes which redirect stdout to the target of the rule (i.e., constructs
+# like cmd > $@) create empty or incomplete output files if the command fails,
+# for example when cmd was not found. Since the target exists and is uptodate
+# in this case, this may lead to all sorts of problems. The following target
+# makes sure that such files are removed.
+.DELETE_ON_ERROR:
+
 PREFIX ?= /usr/local
 M4 := m4
 LN := ln -f
@@ -18,8 +25,19 @@
 GROFF := groff
 CP := cp
 INSTALL := install
-GZIP := gzip -f9
+GZIP := gzip -fn9
 ZCAT := zcat
+
+CC += -ffile-prefix-map=$(CURDIR)=.
+
+dummy != $(M4) /dev/null || printf 'failed'
+ifeq ($(dummy), failed)
+$(error m4 is required to build this package)
+endif
+dummy != printf '%%%%\n' | $(LEX) -o /dev/null || printf 'failed'
+ifeq ($(dummy), failed)
+$(error (f)lex is required to build this package)
+endif
 
 DATE_FMT := +%B %Y
 # To get a reproducible build, we use $(SOURCE_DATE_EPOCH) instead of the
@@ -79,13 +97,17 @@
 liblopsub_objs := config_file.o lopsub.o version.o
 lopsubex_objs := lopsubex.o lopsubex.lsg.o $(liblopsub_objs)
 
+LLS_CFLAGS := -g -fPIC
+STRICT_CFLAGS := -Wall
+STRICT_CFLAGS += -Werror-implicit-function-declaration
+
 $(lsg_objs) $(liblopsub_objs) $(lopsubex_objs): %.o: %.c
 lopsubgen.o config_file.o:
-	$(CC) -g -c -fPIC -o $@ ${@:.o=.c}
+	$(CC) $(CPPFLAGS) $(LLS_CFLAGS) $(CFLAGS) -c -o $@ ${@:.o=.c}
 lsg1.o: lsg.c lsg.h
-	$(CC) -g -DSTAGE1 -Wall -g -c $< -o $@
+	$(CC) $(CPPFLAGS) $(LLS_CFLAGS) $(STRICT_CFLAGS) $(CFLAGS) -DSTAGE1 -c -o $@ $<
 %.o: %.c
-	$(CC) -Wall -I. -g -c -fPIC -o $@ $<
+	$(CC) -I. $(CPPFLAGS) $(LLS_CFLAGS) $(STRICT_CFLAGS) $(CFLAGS) -c -o $@ $<
 
 # linking
 lopsubgen-stage1: $(lsg1_objs)
@@ -99,17 +121,14 @@
 
 # web
 html := $(addprefix web/, $(addsuffix .html, \
-	index lopsub-api lopsubgen.1 lopsubex.1 $(m4_man_pages)))
-$(html): $(addprefix web/, $(addsuffix .html, header footer))
-
+	index lopsub-api lopsubgen.1 lopsubex.1 $(m4_man_pages:.gz=)))
 www: $(html)
-
-web/lopsub-api.html: lopsub.h.m4
+web/lopsub-api.html: lopsub.h.m4 web/header.html web/footer.html
 	$(M4) -DOUTPUT_MODE=HTML web/header.html $(gendoc) \
 		$< web/footer.html > $@
 web/index.html: web/lopsub.7.html
 	$(LN) -s $(notdir $<) $@
-web/%.html: %.gz
+web/%.html: %.gz web/header.html
 	$(CP) web/header.html $@
 	$(ZCAT) $< | $(GROFF) -m man -Thtml | sed -e '1,/^<body>/d' >> $@

=== debian/changelog ===
liblopsub (1.0.4-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:12:25 +0000

liblopsub (1.0.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062407

 -- Steve Langasek <vorlon@debian.org>  Fri, 01 Mar 2024 05:37:06 +0000

liblopsub (1.0.4-1) unstable; urgency=low

  * Make the build reproducible (Chris Lamb, Vagrant Cascadian). Closes:
    #1039617, #1039618
  * Avoid crash due to a NULL pointer dereference in certain cases
  * Minor cleanups and fixes, see NEWS for details.

 -- Andre Noll <maan@tuebingen.mpg.de>  Sun, 02 Jul 2023 14:12:13 +0200

liblopsub (1.0.3-2) unstable; urgency=low

  * Make the output of lopsubgen reproducible.
  * Don't embed compile-time timestamps into generated files.

 -- Andre Noll <maan@tuebingen.mpg.de>  Fri, 12 Jul 2019 20:55:26 +0200

liblopsub (1.0.3-1) unstable; urgency=low

  * The only change relative to 1.0.2-1 is the update of the standards
    version field in debian/control. See NEWS for the changes between
    1.0.2 and 1.0.3.

 -- Andre Noll <maan@tuebingen.mpg.de>  Sun, 19 May 2019 16:58:44 +0100

liblopsub (1.0.2-1) unstable; urgency=low

  * Initial Release. Closes: #925911

 -- Andre Noll <maan@tuebingen.mpg.de>  Sun, 3 Mar 2019 00:37:31 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,18 @@
 Source: liblopsub
 Section: libdevel
 Priority: optional
-Maintainer: Andre Noll <maan@tuebingen.mpg.de>
-Build-Depends: m4, flex, debhelper (>= 10.0)
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andre Noll <maan@tuebingen.mpg.de>
+Build-Depends: dpkg-dev (>= 1.22.5), m4, flex, debhelper (>= 10.0)
 Standards-Version: 4.3.0
 Homepage: http://people.tuebingen.mpg.de/maan/lopsub
 Vcs-Browser: http://git.tuebingen.mpg.de/lopsub.git
 Vcs-Git: git://git.tuebingen.mpg.de/lopsub.git
 
-Package: liblopsub1
+Package: liblopsub1t64
+Provides: ${t64:Provides}
+Replaces: liblopsub1
+Breaks: liblopsub1 (<< ${source:Version})
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Long Option Parser for Subcommands
@@ -25,7 +29,7 @@
 
 Package: liblopsub-dev
 Architecture: any
-Depends: ${shlibs:Depends}, liblopsub1 (= ${binary:Version}), ${misc:Depends}
+Depends: ${shlibs:Depends}, liblopsub1t64 (= ${binary:Version}), ${misc:Depends}
 Description: Long Option Parser for Subcommand - headers
  Lopsub  is  an  open  source library written in C which aims to ease
  the task of creating, documenting and parsing the options of Unix

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # invoked with the package root as the current directory.
 
 sourcepackage := liblopsub
-package := liblopsub1
+package := liblopsub1t64
 devpackage := liblopsub-dev
 
 define checkdir
@@ -49,8 +49,8 @@
 	$(INST_FILE) debian/copyright $(DEVDOCS_DIR)/copyright
 	$(INST_FILE) debian/changelog $(DOCS_DIR)/changelog.Debian
 	$(INST_FILE) debian/changelog $(DEVDOCS_DIR)/changelog.Debian
-	gzip -f9 $(DOCS_DIR)/changelog.Debian
-	gzip -f9 $(DEVDOCS_DIR)/changelog.Debian
+	gzip -fn9 $(DOCS_DIR)/changelog.Debian
+	gzip -fn9 $(DEVDOCS_DIR)/changelog.Debian
 	dh_makeshlibs
 	dh_shlibdeps
 	dh_strip

## liblopsub 1.0.5

=== Makefile ===
--- 
+++ 
@@ -113,9 +113,13 @@
 lopsubgen-stage1: $(lsg1_objs)
 	$(CC) -Wall -g $(lsg1_objs) -o $@
 lopsubgen: $(lsg_objs)
-	$(CC) -Wall -g -o $@ $(lsg_objs)
+	$(CC) -Wall -g $(LDFLAGS) -o $@ $(lsg_objs)
 $(REALNAME): $(liblopsub_objs)
-	$(CC) --shared -Wl,-soname,liblopsub.so.$(MAJOR_VERSION) -o $@ $^
+	$(CC) --shared -Wl,-soname,liblopsub.so.$(MAJOR_VERSION) \
+		$(LDFLAGS) -o $@ $^
+liblopsub.a: $(liblopsub_objs)
+	$(AR) -rcs $@ $^
+
 lopsubex: $(lopsubex_objs) $(REALNAME)
 	$(CC) -Wall -g -o $@ $(lopsubex_objs)
 
@@ -151,4 +155,4 @@
 distclean: clean
 	$(RM) *.lsg.c *.lsg.h lopsubgen.c config_file.c lopsubgen-stage1 \
 		lopsub.h lopsub.7 lopsub-suite.5 version.c
-
+-include Makefile.local

=== debian/changelog ===
liblopsub (1.0.5-1) unstable; urgency=medium

  * prefer https:// over http:// and git://
  * make the build lintian-clean

 -- Andre Noll <maan@tuebingen.mpg.de>  Sat, 11 May 2024 21:02:48 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: liblopsub
 Section: libdevel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andre Noll <maan@tuebingen.mpg.de>
+Maintainer: Andre Noll <maan@tuebingen.mpg.de>
 Build-Depends: dpkg-dev (>= 1.22.5), m4, flex, debhelper (>= 10.0)
-Standards-Version: 4.3.0
-Homepage: http://people.tuebingen.mpg.de/maan/lopsub
-Vcs-Browser: http://git.tuebingen.mpg.de/lopsub.git
-Vcs-Git: git://git.tuebingen.mpg.de/lopsub.git
+Standards-Version: 4.6.2
+Homepage: https://people.tuebingen.mpg.de/maan/lopsub
+Vcs-Browser: https://git.tuebingen.mpg.de/lopsub.git
+Vcs-Git: https://git.tuebingen.mpg.de/lopsub.git
 
 Package: liblopsub1t64
+Section: libs
 Provides: ${t64:Provides}
 Replaces: liblopsub1
 Breaks: liblopsub1 (<< ${source:Version})
@@ -25,7 +25,6 @@
  be included in the application), or to a manual page.  The library
  supports single-character short options and GNU-style long  options.
  The public API is well documented and stable.
-Homepage: http://people.tuebingen.mpg.de/maan/lopsub
 
 Package: liblopsub-dev
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,6 @@
 # Invoke each target with `./debian/rules <target>'.  All targets should be
 # invoked with the package root as the current directory.
 
-sourcepackage := liblopsub
 package := liblopsub1t64
 devpackage := liblopsub-dev
 
@@ -19,9 +18,14 @@
 DEVDOCS_DIR := $(DEVDIR)/usr/share/doc/$(devpackage)
 TRIPLET := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
+# activate the dh sequencer
+%:
+	dh "$@"
+
 build-arch:
 	$(checkdir)
-	$(MAKE)
+	$(MAKE) $(shell DEB_BUILD_MAINT_OPTIONS=hardening=+all \
+		dpkg-buildflags --export=cmdline)
 build-indep:
 build: build-indep build-arch
 
@@ -43,6 +47,7 @@
 	mv $(TMPDIR)/usr/lib-$(TRIPLET) $(TMPDIR)/usr/lib/$(TRIPLET)
 	dh_install -p $(package)
 	dh_install -p $(devpackage)
+	dh_lintian
 	$(MAKE_DIR) $(DESTDIR)/DEBIAN $(DOCS_DIR) $(DEVDOCS_DIR)
 	echo 'activate-noawait ldconfig' > $(DESTDIR)/DEBIAN/triggers
 	$(INST_FILE) debian/copyright $(DOCS_DIR)/copyright
@@ -56,6 +61,7 @@
 	dh_strip
 	dh_shlibdeps
 	dh_gencontrol
+	dh_md5sums
 	dh_builddeb
 
 binary-indep binary-arch: binary

=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=gittag" \
	https://git.tuebingen.mpg.de/lopsub/ \
	refs/tags/v@ANY_VERSION@
